<?php
/***************************************************************************
 *                             convert_phpkit.php
 *                            --------------------
 *   begin                : Saturday, Jan 22, 2005
 *   copyright            : Yves Schumann
 *   email                : ys@fh-zwickau.de
 *
 *   $Id: convert_phpkit.php,v 1.1 2005/01/29 00:00:00 StarWarsFan Exp $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

/******
 *
 *	This converter will import:
 *
 *	- userdata including signatures and passwords
 *  - all forums with their names
 *  - all threads with their posts
 *  - the names of the avatar-files
 *
 *
 *	This converter will NOT:
 *
 *	- import features that are not supported by phpBB 2.0.11
 *  - sort the threads into their topics so you have to do this by hand 
 *    using the "moderate this forum"-link in the forum
 *  - copy the avatar files (have to work on this and will implement in the next version)
 *
 ******/

$converter_infos = array(
	'forum_name'	=>	'phpKit 1.6.03',
	'version'		=>	'1.1',
	'table_prefix'	=>	'phpkit_',
	'phpbb_version'	=>	'2.0.11',
	'author'		=>	'<a href="http://www.fh-zwickau.de/~ys" target="_new">Yves Schumann</a>',
	'pre_message'	=>	'<table width="30%">
							<tr>
								<td>Now the conversion can begin...<br>
									<br>
									The converter will convert and transfer the following data to the phpBB database:
									<ul>
										<li>userdata including signatures and passwords</li>
										<li>all forums with their names</li>
										<li>all threads with their posts</li>
										<li>the names of the avatar-files</li>
									</ul>
									The converter can\'t do the following:
									<ul>
										<li>import features that are not supported by phpBB 2.0.11</li>
										<li>Sort the threads into their topics so you have to do this by hand 
											using the "moderate this forum"-link in the forum</li>
										<li>copy the avatar-files (in this version)</li>
									</ul>
								</td>
							</tr>
						</table>'
	);

$tables = array(
	'adview',
	'blacklist',
	'buddy',
	'calender',
	'comment',
	'config',
	'content',
	'content_submited',
	'contentcat',
	'contenttheme',
	'faq',
	'faqcat',
	'forumcat',
	'forumfav',
	'foruminfo',
	'forumnotify',
	'forumpost',
	'forumrank',
	'forumthread',
	'forumvote',
	'gbook',
	'im',
	'navigation',
	'navigationcat',
	'profilefields',
	'record',
	'recordip',
	'session',
	'smilies',
	'style',
	'templatepack',
	'templates',
	'user',
	'userfields',
	'usergroup',
	'vote',
	'vote_rated',
	'votetheme'
);

$config_schema = array(
	'table_name'	=>	'config',
	'table_format'	=>	'fixed',
	'settings'		=>	array(
		'avatar_filesize'		=>	'avatar_size',
		'avatar_gallery_path'	=>	'avatar_path',
		'avatar_max_height'		=>	'avatar_height',
		'avatar_max_width'		=>	'avatar_width',
		'avatar_path'			=>	'avatar_path',
		'board_email'			=>	'site_email',
		'board_timezone'		=>	'time_gmtzone',
		'sitename'				=>	'site_name'
	)
);

if ($get_info)
{
	return;
}

$converter = array(
//	'test_file'		=>	'admin/nav.php',
//	'avatars_path'	=>	'',

//	'execute_first'	=>	'
//		kit_avatar_gallery();
//	',
//	'execute_last'	=>	'
//		kit_restore_moderators();
//	',

	'schema' => array(
		array(
			'target'		=>	CATEGORIES_TABLE,
			'query_first'	=>	'DELETE FROM ' . CATEGORIES_TABLE,

			array('cat_id',					'forumcat.forumcat_id',			''),
			array('cat_title',				'forumcat.forumcat_name',		''),
			array('cat_order',				'',								'')
		),

		array(
			'target'		=>	FORUMS_TABLE,
			'query_first'	=>	'DELETE FROM ' . FORUMS_TABLE,

			array('forum_id',				'forumcat.forumcat_id',					''),
			array('cat_id',					'1',									''),
			array('forum_name',				'forumcat.forumcat_name',				''),
			array('forum_desc',				'forumcat.forumcat_description',		''),
			array('forum_status',			'forumcat.forumcat_status',				'kit_forum_status'),
			array('forum_posts',			'forumcat.forumcat_postcount',			''),
			array('forum_topics',			'forumcat.forumcat_threadcount',		''),
			array('forum_last_post_id',		'forumcat.forumcat_lastreply_autorid',	''),

//			'where'		=> '(forum.FID = thread.FID AND thread.TID = post.TID) OR forum.replycount = 0',
			'group_by'	=> 'forumcat.forumcat_id',
			'order_by'	=> 'forumcat.forumcat_id ASC'
		),

		array(
			'target'		=>	POSTS_TABLE,
			'query_first'	=>	'DELETE FROM ' . POSTS_TABLE,

			array('post_id',				'forumpost.forumpost_id',			''),
			array('topic_id',				'forumpost.forumpost_threadid',		''),
			array('forum_id',				'forumcat.forumcat_id',				''),
			array('poster_id',				'forumpost.forumpost_autorid',		''),
			array('post_time',				'forumpost.forumpost_time',			''),
			array('poster_ip',				'forumpost.forumpost_ipaddr',		'encode_ip'),
			array('post_username',			'forumpost.forumpost_autor',		''),
			array('enable_bbcode',			'forumpost.forumpost_bbcode',		''),
			array('enable_smilies',			'forumpost.forumpost_smilies',		''),
			array('post_edit_time',			'forumpost.forumpost_edittime',		''),
			array('post_edit_count',		'forumpost.forumpost_editcount',	''),

//			'where'		=>	'post.TID = thread.TID',
			'group_by'	=>	'forumpost.forumpost_id',
			'order_by'	=>	'forumpost.forumpost_id ASC'
		),
		
		array(
			'target'		=>	POSTS_TEXT_TABLE,
			'query_first'	=>	'DELETE FROM ' . POSTS_TEXT_TABLE,

			array('post_id',				'forumpost.forumpost_id',			''),
			array('bbcode_uid',				'forumpost.forumpost_id',			'make_uid'),
			array('post_subject',			'forumpost.forumpost_title',		'stripslashes'),
			array('post_text',				'forumpost.forumpost_text',			'kit_prepare_message'),

			'order_by'	=>	'forumpost.forumpost_id ASC'
		),
		
		array(
			'target'		=>	TOPICS_TABLE,
			'query_first'	=>	'DELETE FROM '.TOPICS_TABLE,

			array('topic_id',				'forumpost.forumpost_threadid',		''),
			array('forum_id',				'forumcat.forumcat_id',				''),
			array('topic_title',			'forumpost.forumpost_title',		'stripslashes'),
			array('topic_poster',			'forumpost.forumpost_autorid',		''),
			array('topic_time',				'forumpost.forumpost_time',			''),
			array('topic_first_post_id',	'MIN(forumpost.forumpost_id) AS first_post_id',	''),
			array('topic_last_post_id',		'MAX(forumpost.forumpost_id) AS last_post_id',	''),

//			'where'		=>	'forumpost.forumpost_threadid = posts.topic_id',
			'group_by'	=>	'forumpost.forumpost_threadid',
			'order_by'	=>	'forumpost.forumpost_id ASC'
		),
		
		array(
			'target'		=>	USERS_TABLE,
			'query_first'	=>	'DELETE FROM ' . USERS_TABLE . ' WHERE user_id <> ' . -1,

			array('user_id',				'user.user_id',					''),
			array('username',				'user.user_name',				''),
			array('user_password',			'user.user_pw',					''),
			array('user_email',				'user.user_email',				''),
			array('user_viewemail',			'user.user_emailshow',			''),
			array('user_attachsig',			'1',							''),
			array('user_website',			'user.user_hpage',				'validate_website'),
			array('user_aim',				'user.user_aimid',				''),
			array('user_yim',				'user.user_yim',				''),
			array('user_icq',				'user.user_icqid',				'validate_icq'),
			array('user_msnm',				'user.user_msnid',				''),
			array('user_sig',				'user.user_sig',				'kit_prepare_sig'),
			array('user_interests',			'user.user_hobby',				''),
			array('user_regdate',			'user.signin',					''),
			array('user_posts',				'user.user_posts',				''),
			array('user_level',				'user.user_status',				'kit_user_status_to_userlevel'),
			array('user_avatar',			'user.user_avatar',				''),

			'order_by'	=>	'user.signin ASC'
		),
	)
);

//
// Converter-specific functions
//


function kit_convert_gender($message)
{
	if($message == "w")								// phpKit use m and w, phpBB use 0 and 1
	{
		return "0";
	}else{
		return "1";
	}			
}

function kit_user_status_to_userlevel($status)
{
	switch (ucfirst(strtolower($status)))
	{
		case 'Admin':
		return 1;

		default:
		return 0;
	}
}

function kit_avatar($filename)
{
	if (!empty($filename))
	{
		return 'kitBoard/' . basename($filename);
	}
}

function kit_avatar_type($filename)
{
	if (!empty($filename))
	{
		return USER_AVATAR_GALLERY;
	}
}

function kit_avatar_gallery()
{
	global $board_config;
	copy_dir('images/avatars/', path($board_config['avatar_gallery_path']) . 'kitBoard/');
}

function kit_forum_status($var)
{
	return ($var) ? 0 : 1;		// if var = 1 return 0 else return 1
}

function kit_prepare_message($message)
{
	load_bbcode();
	$bbcode_uid = make_uid_from_field('forumpost_id');
	$message = prepare_message(stripslashes($message), FALSE, TRUE, TRUE, $bbcode_uid);

	return $message;
}

function kit_prepare_sig($message)
{
	load_bbcode();
	$bbcode_uid = make_uid_from_field('user_name');
	$message = prepare_message(stripslashes($message), FALSE, TRUE, TRUE, $bbcode_uid);

	return $message;
}

function kit_restore_moderators()
{
	global $db, $src_table_prefix;

	$sql = 'SELECT * FROM ' . $src_table_prefix . 'moderator';
	if (!$result = $db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Could not obtain moderators from kitBoard table.', '', __LINE__, __FILE__, $sql);
	}
	while ($row = $db->sql_fetchrow($result))
	{
		$user_id = kit_username_to_userid($row['moderator']);
		$sql = 'UPDATE ' . AUTH_ACCESS_TABLE
			. ' SET auth_mod = 1'
			. ' WHERE group_id = ' . $user_id . ' AND forum_id = ' . $row['FID'];

		if (!$db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not set moderator ' . $row['moderator'] . ' for forum ' . $row['FID'], __LINE__, __FILE__, $sql);
		}
		if (!$db->sql_affectedrows())
		{
			$sql = 'INSERT INTO ' . AUTH_ACCESS_TABLE . ' (group_id, forum_id, auth_mod)'
				. " VALUES ($user_id, " . $row['FID'] . ', 1)';
			if (!$db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, 'Could not insert moderator ' . $row['moderator'] . ' for forum ' . $row['FID'], __LINE__, __FILE__, $sql);
			}
		}
	}
}

function kit_store_users()
{
	global $db, $src_table_prefix;

	$sql = 'SELECT username FROM ' . $src_table_prefix . 'members ORDER BY register ASC';
	if (!$result = $db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Could not obtain kitBoard members list.', '', __LINE__, __FILE__, $sql);
	}

	$user_id = 2;
	$kit_users = array();
	while ($row = $db->sql_fetchrow($result))
	{
		$kit_users[$row['username']] = $user_id;
		++$user_id;
	}
	return $kit_users;
}

function kit_username_to_userid($username)
{
	static $kit_users;
	if (!isset($kit_users))
	{
		$kit_users = kit_store_users();
	}
	return (empty($kit_users[$username])) ? -1 : $kit_users[$username];
}
?>